fl

{
   LCD's Brightness&Contrast Driver for an HD44780 based LCD Character based display
    PropForth 4.0a compatible
    2011/4/16

     contrast             P6   0x6
     brightness           P7   0x7
     
}

\ waitcnt ( n1 n2 -- n3 ) \ wait until n1, n3 = n1 + n2
: waitcnt _execasm2>1 1F1 _cnip ;

1F8	wconstant ctra 
1FA	wconstant frqa
1FC	wconstant phsa
6 wconstant _contrast
7 wconstant _bright
13880 constant 1msec     \ 1msec tics

wvariable cog
variable b_cycle
variable b_duty_on
variable c_cycle
variable c_duty_on
wvariable pwm1
wvariable pwm2

1 _contrast lshift constant _contrastm
1 _bright lshift constant _brightm

: _cont_out_l _contrastm _maskoutlo ;
: _cont_out_h _contrastm _maskouthi ;
: _bright_out_l _brightm _maskoutlo ;
: _bright_out_h _brightm _maskouthi ;

: set_contrast   \ setting contrast for LCD ( n1 n2 -- ) n1:duty factor(%)  n2:cycle(ms)
io io>cog cog W@ or cog W!              
4 1a lshift _contrast or ctra COG!
1 frqa COG!
_contrast pinout
1msec u* c_cycle L!
c_cycle L@ u* 64 u/ c_duty_on L!                        1
cnt COG@ c_duty_on L@ +
begin
     c_duty_on L@ negate phsa COG!
     c_cycle L@ waitcnt
0 until     
;
\ Option
: set_bright     \ setting contrast  ( n1 n2 -- ) n1:duty factor(%)  n2:cycle(ms)
io io>cog 4 lshift cog W@ or cog W! 
4 1a lshift _bright or ctra COG!
1 frqa COG!
_bright pinout
1msec u* b_cycle L!
b_cycle L@ u* 64 u/ b_duty_on L!                        1
cnt COG@ b_duty_on L@ + 
begin
     b_duty_on L@ negate phsa COG!
     b_cycle L@ waitcnt  
0 until 
;

: change_contrast   \ change contrast ( n1 n2 -- ) n1:duty factor(%)  n2:cycle(ms)
2dup 0= swap 0= or 0=
if
     swap dup 64 > if drop 64 then swap
     cog W@ f and 4 = if 4 cogreset cog W@ f0 and cog W! then
     pwm2 W! pwm1 W!
     c" pwm1 W@ pwm2 W@ set_contrast" 4 cogx
then     
;

: change_bright   \ change brightness  ( n1 n2 -- ) n1:duty factor(%)  n2:cycle(ms)
2dup 0= swap 0= or 0=
if
     swap dup 64 > if drop 64 then swap
     cog W@ f0 and 50 = if 5 cogreset cog W@ f and cog W! then
     pwm2 W! pwm1 W!
     c" pwm1 W@ pwm2 W@ set_bright" 5 cogx
then
;

: bright_init
cog W@ f0 and 50 <>
if
     c" 32 5 set_bright" 5 cogx        \ set LCD's backlight to duty=50% cycle time=5msec
     6 delms        \ wait
     cog W@ f0 and 50 <> if ." cog5 for brightness don't start" cr then
then
;

: contrast_init
cog W@ f and 4 <>
if 
     c" 55 5 set_contrast" 4 cogx        \ set LCD's contrast to 80%
     6 delms        \ wait
     cog W@ f and 4 <> if ." cog4 for contrast don't start" then
then
;


: sleep
8 lcd_com      \ display OFF
cog W@ f and 4 = if 4 cogreset then
cog W@ f0 and 50 = if 5 cogreset then
0 cog W!
;
: wakeup
c lcd_com      \ display ON
c" 32 5 set_bright" 5 cogx        \ set LCD's backlight to duty=50% cycle time=5msec
6 delms        \ wait
cog W@ f0 and 50 <> if ." cog5 for brightness don't start" cr then
c" 28 5 set_contrast" 4 cogx        \ set LCD's contrast to 80%
6 delms        \ wait
cog W@ f and 4 <> if ." cog4 for contrast don't start" then
;
    