fl

{
   LCD's Brightness&Contrast Driver for an HD44780 based LCD Character based display
    PropForth 4.0a compatible
    2011/04/23 21:31:00

     contrast             P6   0x6
     brightness           P7   0x7
     
}

\ waitcnt ( n1 n2 -- n3 ) \ wait until n1, n3 = n1 + n2
: waitcnt _execasm2>1 1F1 _cnip ;

1F8	wconstant ctra 
1FA	wconstant frqa
1FC	wconstant phsa
6 wconstant _contrast
7 wconstant _bright
13880 constant 1msec     \ 1msec tics

wvariable cog       \ cog's id-number   bit7-4:contrast    bit3-0:brightness
variable b_cycle
variable b_duty_on
variable c_cycle
variable c_duty_on
wvariable pwm1
wvariable pwm2

1 _contrast lshift constant _contrastm
1 _bright lshift constant _brightm

: _cont_out_l _contrastm _maskoutlo ;
: _cont_out_h _contrastm _maskouthi ;
: _bright_out_l _brightm _maskoutlo ;
: _bright_out_h _brightm _maskouthi ;

\ alloc_cog( -- n1 ) n1 - a cog or -1 if the allocation fails
: alloc_cog
    lockdict
    (nfcog)
    if
\                \ no free cogs
        drop -1
    else
\                \ mark it busy
        4 over cogstate andnC!
    then
\                \ semaphore end
    freedict   
;

\ free_cog ( n1 -- ) free cog n1
: free_cog
    4 swap cogstate orC!
;       

: set_extra         \ setting contrast/bright for LCD ( n1 n2 n3 -- ) n1:duty factor(%)  n2:cycle(ms)
                    \ n3:0 or 1   0=Contrast  1=Brightness
dup 0=
if io io>cog cog W@ f0 and or cog W!
else io io>cog 4 lshift cog W@ f and or cog W!
then
             
\ 4 1a lshift _contrast or ctra COG!
\ 1 frqa COG!
0= if 10000000 _contrast or ctra COG! _contrast 
   else 10000000 _bright or ctra COG! _bright 
   then pinout
1 frqa COG!
   
1msec u* c_cycle L!
c_cycle L@ u* 64 u/ c_duty_on L!                        1
cnt COG@ c_duty_on L@ +
begin
     c_duty_on L@ negate phsa COG!
     c_cycle L@ waitcnt
0 until     

;


: change_extra       \ change contrast ( n1 n2 n3 -- ) n1:duty factor(%)  n2:cycle(ms)
                     \ n3:0 or 1   0=Contrast  1=Brightness
rot2
2dup 0= swap 0= or 0=
if
     swap dup 64 > if drop 64 then swap
     pwm2 W! pwm1 W!
     
     alloc_cog dup -1 <>
     if swap 0= 
        if cog W@ f and cogreset 
            c" pwm1 W@ pwm2 W@ 0 set_extra" swap cogx
        else cog W@ f0 and 4 rshift cogreset 
            c" pwm1 W@ pwm2 W@ 1 set_extra" swap cogx
        then
     else 2drop if ." Contrast can't control" else ." Brightness can't control" then
     then
else 3drop   
then                          
;

\ initialize Contrast or Brightness for LCD  (n -- ) n:0 or 1   0=Contrast  1=Brightness
: lcd_extra_init
alloc_cog dup -1 <>
if swap 0= if         \ set LCD's contrast to 80%
                c" 55 5 0 set_extra" swap cogx
           else         \ set LCD's backlight to duty=50% cycle time=5msec
                c" 32 5 1 set_extra" swap cogx
           then
else drop if ." Contrast can't control" else ." Brightness can't control" 
thens
;

: sleep
8 lcd_com      \ display OFF
cog W@ dup f and swap f0 and 4 rshift 
2 0 do dup cogreset free_cog loop
ff cog W!
;

: wakeup
c lcd_com      \ display ON
2 0 do i lcd_extra_init loop
;
    