fl

{
Denpatokei(Radio Controlled Clock)
    PropForth 4.0/4.0a compatible 
    2011/1/29

}


: _LED_out_l _LEDm _maskoutlo ;
: _LED_out_h _LEDm _maskouthi ;
: _flag60_out_l _flag60m _maskoutlo ;
: _flag60_out_h _flag60m _maskouthi ;

\ waitpeq ( n1 n2 -- ) \ wait until state n1 is equal to ina anded with n2
: waitpeq _execasm2>0 1E0 _cnip ;

: 200ms? dup 300ms < swap 100ms > and ;
: 500ms? dup 600ms < swap 400ms > and ;
: 800ms? dup 900ms < swap 700ms > and ;
        
\ ( -- time_count_ticks)    
: Time
0 _signalm waitpeq       \ wait for _signalm to go to low 
0 phsa COG!
_LED_out_h
_signalm _signalm waitpeq     \ wait for _signalm to go to high       
phsa COG@
     dup .  
_LED_out_l
;

\ ( -- 0|1|2 )
: Time_convert
Time
dup 800ms? if drop 0
           else 500ms? if 1
                       else 2
           thens
     space dup . cr
;                        

: Frame_top
0
begin
     Time 200ms? if if 1 else 1 0 then 
                 else drop 0 0
                 then
until
;
    
: Get_minute
0 minute W!
0 P_minute W!
1                   \ error_flag
8 0 do
     Time_convert 
     dup P_minute W@ + P_minute W!
     i 3 = if 0 > if ibound seti drop 0 then      \ error
           else dup 1 = if drop m_data 2+ i + C@ minute W@ + minute W!
                        else 2 = if ibound seti drop 0     \ error
           thens
    loop
;

: Get_Mark Time 200ms? ;
            
: Get_hour
0 hour W!
0 P_hour W!
1                   \ error_flag
9 0 do
     Time_convert 
     dup P_hour W@ + P_hour W!
     i 2 < i 4 = or if 0 > if ibound seti drop 0 then      \ error
                    else dup 1 = if drop h_data 2+ i + C@ hour W@ + hour W!
                             else 2 = if ibound seti drop 0     \ error             
                    thens
    loop
;

: Get_Pass1
0 date W!
1                   \ error_flag
9 0 do
     Time_convert
     i 2 < i 4 = or if 0 > if ibound seti drop 0 then      \ error 
                    else dup 1 = if drop d_data1 2+ i + C@ date W@ + date W!
                                 else 2 = if ibound seti drop 0      \ error
                    thens
    loop
;
         
: Get_Pass2
1                   \ error_flag
9 0 do
     Time_convert
     i 4 < if dup 1 = if drop d_data2 2+ i + C@ date W@ + date W!
                      else 2 = if ibound seti drop 0 then    \ error
                      then
           else i 4 = i 5 = or if 0 > if ibound seti drop 0 then      \ error
                               else i 6 = if P_hour W@ <> if drop 0 then     \ error
                                          else i 7 = if P_minute W@ <> if drop 0 then
                                                     else i 8 = if 2 = if drop 0     \ error
           thens                                                      
    loop
;

: Get_year
0 year W!
1                   \ error_flag
9 0 do
     Time_convert
     i 0 > if dup 1 = if drop y_data 2+ i + C@ year W@ + year W!
                      else 2 = if ibound seti drop 0 then    \ error
                      then
           else 2 = if ibound seti drop 0      \ error
           thens       
    loop              
;

: Get_week
0 week W!
1                   \ error_flag
9 0 do
     Time_convert
     i 3 < if dup 1 = if drop w_data 2+ i + C@ week W@ + week W!
                      else 2 = if ibound seti drop 0 then     \ error
                      then
           else 2 = if ibound seti drop 0     \ error
           thens
    loop       
;
     
: denpatokei
\ initialize
30000000 _signal or ctra COG!      \ NEG detector
1 frqa COG!
dira COG@ _LEDm or dira COG!       \ set _LED to output-port
dira COG@ _flag60m or dira COG!       \ set _Tcheck to output-port

c" prop_clock" 5 cogx              \ start prop_clock
c" monitor" 4 cogx                 \ start monitoring
c" diff" 3 cogx

\ main-routin  decoding time-information
begin
      Frame_top
      Get_minute
      if Get_Mark   ." P1" cr   \ P1
         if P_minute W@ 2 u/mod drop P_minute W!   \ minute parity
            Get_hour
            if Get_Mark    ." P2" cr  \ P2
               if P_hour W@ 2 u/mod drop P_hour W!
                  Get_Pass1
                  if Get_Mark    ." P3" cr  \ P3
                     if Get_Pass2
                        if Get_Mark    ." P4" cr  \ P4
                           if minute W@ dup f = swap 2d = or      \ 15minute or 45minute?
                              if year W@ 7d0 swap - year W! ." skip p4-P5" cr 9 delsec 1
                              else Get_year
                              then
                              if Get_Mark   ." P5" cr   \ P5 
                                 if minute W@ dup f = swap 2d = or      \ 15minute or 45minute?
                                    if week W@ 7d0 swap - week W! ." skip P5-P0" cr 9 delsec 1
                                    else Get_week
                                    then
                                    if Get_Mark       \ P0
                                       if 0 _signalm waitpeq       \ wait for _signalm to go to low 
                                          cnt COG@          \ B
                                          _flag60_out_h 1 delms _flag60_out_l
                                          ." success" cr                                        
                                         5 cogreset                   \ stop prop_clock
                                         \ copy variables for prop_clock
                                                 minute W@ prop_minute W!
                                                 hour W@ prop_hour W!
                                                 date W@ prop_date W!
                                                 year W@  7d0 + prop_year W!
                                                 week W@ prop_week W!      
                                          c" prop_clock" 5 cogx       \ restart prop_clock
                                                 
                                          cnt COG@ swap - .      \ B' 
                                          0
                                       else ." P0 error" cr 0
                                       then
                                    else ." P5-P0 error" cr 0
                                    then
                                 else ." P5 error" cr 0
                                 then
                              else ." P4-P5 error" cr 0
                              then
                           else ." P4 error" cr 0
                           then
                        else ." P3-P4 error" cr 0
                        then
                     else ." P3 error" cr 0
                     then
                  else ." P2-P3 error" cr 0
                  then
               else ." P2 error" cr 0
               then
            else ." P1-P2 error" cr 0
            then
         else ." P1 error" cr 0
         then
      else ." P0-P1 error" cr 0
      then
\ st?
until
; 
