fl

{
dynamic_drive_7SEG_LED (Using Cathode Common LED)   up to 8digits
    PropForth 4.0/4.0a compatible
    2011/02/28 11:26:15
}

: .long dup 10 rshift .word .word ;
: _sttop 2e _cv ;
: _stptr 5 _cv ;  
: st? ." ST: " _stptr COG@ 2+ dup _sttop < if _sttop swap - 0 do _sttop 2- i -  COG@ .long space loop else drop then cr ;

\ constant ( x -- ) skip blanks parse the next word and create a constant, allocate a long, 4 bytes
: constant lockdict create $C_a_doconl w, l, forthentry freedict ;
0 _crf W!
: variable lockdict create $C_a_dovarl w, 0 l, forthentry freedict ; 


\ waitcnt ( n1 n2 -- n1 ) \ wait until n1, add n2 to n1
: waitcnt _execasm2>1 1F1 _cnip ;

\ fit to your hardware
0 wconstant _7seg_data           \ pin for data(bit0) of 7segment_LED   P7 - P0(bit7 -- bit0)
c wconstant _digit              \ pin for digit(low) of LED            P14 - P12(high middle low) 3digits
3 wconstant digits              \ numbers of 7Segment_LED   3-digits
wvariable segment 2 allot       \ segment data for 4-digits   top address is lowest digit   if 8-digits,modify to 6 allot

wvariable cog
variable waitT                 \ time to display at one digit 
1 _7seg_data lshift constant _7seg_datam
1 _digit lshift constant _digitm

\ 7seg_LED-charcter from "0" to "F"
 wvariable 7seg_char 7e c, 30 c, 6d c, 79 c, 33 c, 5b c, 5f c, 70 c, 7f c, 7b c, 77 c, 1f c, 4e c, 3d c, 4f c, 47 c,
\ 7seg_LED-charcter(reverse & mirror letters) from "0" to "F"
\ wvariable 7seg_char 7e c, 30 c, 5b c, 79 c, 35 c, 6d c, 6f c, 38 c, 7f c, 7d c, 3f c, 67 c, 4e c, 73 c, 4f c, 0f c,

\ Set 7Segment's data-port and 7seg-drive-port to output 
: init_7seg     
     \ set 7seg-8bit data from P**(_7seg_data) to P**(_7seg_data+7) to output
_7seg_data 8 0 do dup pinout 1+ loop drop 
     \ set port for digits of 7seg to output
_digit digits 0 do dup pinout 1+ loop drop
;

: set_data_7seg _7seg_data lshift ;
: mask_7seg ff set_data_7seg invert ;  

\ set data for 7segment_7seg  (n -- ) n:digit of 7seg  0=lowest digit 
: set_seg_data segment + C@ set_data_7seg outa COG@ mask_7seg and or outa COG! ;

\ on/off cathode-common-pin  (n -- ) n:number for 7seg's Cathode Common   2=left 1=middle 0=right
: digit_pin_on _digitm swap lshift _maskouthi ;
: digit_pin_off _digitm swap lshift _maskoutlo ;

\ Display 7segment-data inside segment  ( -- )
: 7seg_drive
cog W@ io io>cog 4 lshift or cog W!
init_7seg
cnt COG@ waitT L@ +
begin
     digits 0 do                  
               i set_seg_data
               i digit_pin_on
               waitT L@ waitcnt
               i digit_pin_off 
     loop
     0
until
;

\ Convert number(from 0 to F) to 7Segment data  ( n -- )  n:0 to F
: 7seg_conv 7seg_char 2+ + C@ ;

\ save 7segmet-data(decimal) to variable for 7Seg-LEDs   ( n1 -- n1 )
: set_data
dup dup 3e8 = if 2drop 0 0 then
64 u/mod 7seg_conv segment 2+ C!      \ 3digit
a u/mod 7seg_conv segment 1+ C!    \ 2digit
7seg_conv segment C!         \ 1digit
;

: dd7seg1       \ decimal
io io>cog cog W!
-1
begin
     64 delms
     1+ dup dup      
     1 digits 0 do a u* loop ." 1"  st? dup >r = if 2drop 0 0 then 
     r> a u/     
     digits 0 do 
                dup rot swap u/mod dup -1 = if drop 0 then      ." 2a"  st?
                7seg_conv                                   \ get 7seg_data
                segment ibound 1- i - + C!       \ store character to display-data-area
                swap a u/              
              loop  
     2drop      
0   
until
;

: dd7seg2       \ hex
io io>cog cog W!
-1
begin
     64 delms
     1+ dup
     f digits 1- 4 u* lshift  
     digits 0 do
                dup rot and 1 digits i - 0 do 2 u* loop dup 2 = if drop 0 then rshift   
                7seg_conv                 \ get 7seg_data 
                segment ibound 1- i - + C!   \ store 7seg_data to display-data-area 
                4 rshift swap dup rot     \ 
                loop
     2drop       
0   
until
;

wvariable tmp
wvariable sum
: demo
a3500 waitT L!       
 c" dd7seg1" 4 cogx
\ c" dd7seg2" 4 cogx
c" 7seg_drive" 5 cogx

a 0 do
."  Input dynamic_drive_frequency[Hz](1 - 9999:decimal) > "
0 tmp W!
0 sum W!
begin
     begin
          key dup 30 < if d = if tmp W@ 0> if 1 else 0 then else 0 then
                       else dup 3a > if drop 0
                                     else dup emit tmp W@ 4 = if 5 0 do drop loop
                                                                 0 tmp W!
                                                                 ."  incorect input" cr
                                                                 ."  Input dynamic_drive_frequency[Hz](decimal) > " 0
                                                              else todigit tmp dup W@ 1+ swap W! 0   
                       thens
     until    
     tmp W@ 0 do i 0 > if i 0 do a u* loop then
                    sum W@ + sum W!
              loop
     sum W@ 0= if ."  incorect input" cr 1 else 1 then                  
until
cr
5 cogreset
clkfreq sum W@ u/ dup waitT L!
." delay count value at WORD[7seg_drive]:" ." 0x"  . 
c" 7seg_drive" 5 cogx 
cr cr         
0
loop

4 cogreset
5 cogreset
;


\ ------------------------------
\ Hardware check code  (3digits)
\ ------------------------------

\ check each digit for 7segs
: test1 init_7seg outa COG@ mask_7seg and ff or outa COG! digits 0 do i digit_pin_on 1 delsec i digit_pin_off loop ;

\ Display "210" on 3digit for 7Segment-7seg
: test2   \ ( -- )
300
clkfreq swap u/ dup . waitT L!
7e segment W!
30 segment 2+ W!
6d segment 2+ 2+ W!
7seg_drive
;
   
: test3
a3500 waitT L!       

c" 7seg_drive" 5 cogx

dd7seg1
;
